
// auswertung.cpp
// LFTVideo.cpp  v1.73
//               9.6.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp

#include "auswertung.h"
#include <qlineedit.h>
#include <qtable.h>
#include <qarray.h>
#include <qpushbutton.h>


void VerlaufsAuswertung::DatenAnalysieren(RatingVerlauf* derVerlauf) {
	Verlauf=derVerlauf;
	SummenTabelle.resize(RatingSkalaMax+1);
	for (int i=0; i<=RatingSkalaMax; i++) 
		SummenTabelle[i]=AnzahlDauer(0,0);
	
	int j,k;
    for (i=0; i<8; i++){
		for (j=0; j<8; j++){
			uew[i][j]=0;
			for (k=0; k<8;k++){
				uew2[k][i][j]=0;
			}
		}
	}
	// QString temp; temp="%1"; temp=temp.arg(uew[1][2]);
	// qDebug(temp);
	RatingSkala vorvorherigeEinsch=null, vorherigeEinsch, aktuelleEinsch;

	IntervallErgebnis interv;
	MinSec2Rating::iterator it=Verlauf->Sinneinheiten.begin();
	for ( ; it!=Verlauf->Sinneinheiten.end(); it++){
		interv=Verlauf->RatingAuslesen(it);
		aktuelleEinsch=interv.Einschaetzung;
		if(aktuelleEinsch>0){
			SummenTabelle[aktuelleEinsch].Anzahl++;
			SummenTabelle[aktuelleEinsch].Dauer += interv.Dauer;
		}
		vorherigeEinsch=interv.EinschaetzungDavor;

		uew[vorherigeEinsch][aktuelleEinsch] ++;

		uew2[vorvorherigeEinsch][vorherigeEinsch][aktuelleEinsch] ++;

		vorvorherigeEinsch = vorherigeEinsch;
	}
	/*QString temp;
	for (i=1; i<=RatingSkalaMax; i++) {
		temp="%1 %2 %3"; 
		temp=temp.arg(i).arg(SummenTabelle[i].Anzahl).arg(SummenTabelle[i].Dauer);
		qDebug(temp);
	}*/

	AnzahlTherapeut=0; AnzahlKlient=0;
	DauerTherapeut=0; DauerKlient=0;
	for (i=1; i<=3; i++){
		AnzahlTherapeut += SummenTabelle[i].Anzahl; // 1=TL, 2=TNL, 3=TU
		DauerTherapeut += SummenTabelle[i].Dauer;

		AnzahlKlient += SummenTabelle[i+3].Anzahl;  // 4=KL, 5=KNL, 6=KU
		DauerKlient += SummenTabelle[i+3].Dauer;
	}

	/*
	for (i=0; i<8; i++){
		for (j=0; j<8; j++){
			temp="uew(%1 --> %2) = %3"; temp=temp.arg(i).arg(j).arg(uew[i][j]);
			qDebug(temp);
		}
	}
	*/

	AnteilTherapeutAnzahl = AnzahlTherapeut / (double)GesamtAnzahl(); // 1
	AnteilTherapeutDauer = DauerTherapeut / GesamtDauer(); // 2
	AnteilKlientAnzahl = AnzahlKlient / (double)GesamtAnzahl(); // 3
	AnteilKlientDauer = DauerKlient / GesamtDauer(); // 4 

	LoesfokUnteranzahlTherapeut = SummenTabelle[1].Anzahl / (double) AnzahlTherapeut; // 5
	LoesfokUnterdauerTherapeut = SummenTabelle[1].Dauer / DauerTherapeut; // 6
	LoesfokUnteranzahlKlient = SummenTabelle[4].Anzahl / (double) AnzahlKlient; // 7
	LoesfokUnterdauerKlient = SummenTabelle[4].Dauer / DauerKlient; // 8

	// Passungswerte Klient/Therapeut:
		// Quotient der Unteranzahlen
	double HundertProzentKlient, ProzentTeilAnzahlKlient;
	double HundertProzentTherapeut, ProzentTeilAnzahlTherapeut;
	HundertProzentKlient=AnzahlKlient; 
	ProzentTeilAnzahlKlient=
		100*(double)SummenTabelle[4].Anzahl/HundertProzentKlient;
	HundertProzentTherapeut=AnzahlTherapeut; 
	ProzentTeilAnzahlTherapeut=
		100*(double)SummenTabelle[1].Anzahl/HundertProzentTherapeut;
	PassungAnzahl = 
		runden( ProzentTeilAnzahlKlient/ProzentTeilAnzahlTherapeut * 10000)/10000;

	// Quotient der Unterdauern %
	HundertProzentTherapeut=DauerTherapeut;
	HundertProzentKlient=DauerKlient; 
	double ProzentTeilDauerKlient=100 * SummenTabelle[4].Dauer / HundertProzentKlient;
	double ProzentTeilDauerTherapeut=100 * SummenTabelle[1].Dauer / HundertProzentTherapeut;
	PassungDauer = ProzentTeilDauerKlient/ProzentTeilDauerTherapeut;
	PassungDauer = runden(PassungDauer * 10000)/10000;
	
	// spezielle bergangswahrscheinlichkeiten:
	double nenner;

	// TL->KL / TL->Kxx
	nenner=uew[1][4] + uew[1][5] + uew[1][6];
	AufnahmeLoesFok=(nenner!=0)?(uew[1][4] / nenner):(0);

	// TL->KNL->KL     /      TL->KNL->Kxx
	nenner=uew2[1][5][4]+uew2[1][5][5]+uew2[1][5][6];
	verspaetAufnahmeLoesFok=(nenner!=0)?(uew2[1][5][4] / nenner):(0);

	// KNL->TNL / KNL->Txx
	nenner=uew[5][1] + uew[5][2] + uew[5][3];
	TherapNLAnpassung=(nenner!=0)?(uew[5][2] / nenner):(0);

	// TL->KNL->TNL   /  TL->KNL->Txx
	nenner=uew2[1][5][1] + uew2[1][5][2] + uew2[1][5][3];
	TherapFrustration=(nenner!=0)?(uew2[1][5][2] / nenner):(0);
};


void VerlaufsAuswertung::DatenAnzeigen(LFTVideoAnalyseDialog* diag){
	// Gesamt Einzelanzeigen
	QString temp="%1";	temp=temp.arg(GesamtDauer());
	diag->DauerGesamt->setText(temp);
	temp="%1";	temp=temp.arg(GesamtAnzahl());
	diag->AnzahlGesamt->setText(temp);
	temp="%1";	temp=temp.arg(GesamtAnzahl()-1);
	diag->AnzahlUebergaenge->setText(temp);
	temp="%1";	temp=temp.arg(Durchschnittsdauer());
	diag->mittlereDauerGesamt->setText(temp);
    // Therapeut Einzelanzeigen
	temp="%1"; temp=temp.arg(AnzahlTherapeut);
	diag->AnzahlTherapeut->setText(temp);
	temp="%1"; temp=temp.arg(DauerTherapeut);
	diag->DauerTherapeut->setText(temp);
	temp="%1";	temp=temp.arg(DauerTherapeut/AnzahlTherapeut);
	diag->mittlereDauerTherapeut->setText(temp);
    // Klient Einzelanzeigen
	temp="%1"; temp=temp.arg(AnzahlKlient);
	diag->AnzahlKlient->setText(temp);
	temp="%1"; temp=temp.arg(DauerKlient);
	diag->DauerKlient->setText(temp);
	temp="%1";	temp=temp.arg(DauerKlient/AnzahlKlient);
	diag->mittlereDauerKlient->setText(temp);
    
    // Tabelle Teil-Anzahlen und -Dauern Therapeut
	//                                             AnteilTherapeutAnzahl
	temp="%1%"; temp=temp.arg(runden( 1000*(double)AnzahlTherapeut/GesamtAnzahl() )/10);
	diag->TabSum->setText(0,2,temp);
	//                                             AnteilTherapeutDauer
	temp="%1%"; temp=temp.arg(runden( 1000*(double)DauerTherapeut/GesamtDauer() )/10);
	diag->TabSum->setText(0,6,temp);
	// Tabelle Teil-Anzahlen und -Dauern Klient
	//                                             AnteilKlientAnzahl
	temp="%1%"; temp=temp.arg(runden(1000*(double)AnzahlKlient/GesamtAnzahl() )/10);
	diag->TabSum->setText(3,2,temp);
	//                                             AnteilKlientDauer
	temp="%1%"; temp=temp.arg(runden(1000*(double)DauerKlient/GesamtDauer() )/10);
	diag->TabSum->setText(3,6,temp);

	// Tabelle restliche Werte
	for (int i=1; i<=7; i++) {
		// Anzahl #
		temp="%1"; temp=temp.arg(SummenTabelle[i].Anzahl);
		diag->TabSum->setText(i-1,0,temp);

		// Anzahl %
		double ProzentAnzahl=100*(double)SummenTabelle[i].Anzahl/(double)GesamtAnzahl();
		ProzentAnzahl = runden(ProzentAnzahl * 10)/10;
		temp="%1%"; temp=temp.arg(ProzentAnzahl);
		diag->TabSum->setText(i-1,1,temp);

		// UnterAnzahl %
		double HundertProzent=(i<=3)?AnzahlTherapeut:AnzahlKlient; 
		double ProzentTeilAnzahl=100*(double)SummenTabelle[i].Anzahl/HundertProzent;
		ProzentTeilAnzahl = runden(ProzentTeilAnzahl * 10)/10;
		temp="%1%"; temp=temp.arg(ProzentTeilAnzahl);
		diag->TabSum->setText(i-1,3,temp);

		// Dauer #
		temp="%1"; temp=temp.arg(SummenTabelle[i].Dauer);
		diag->TabSum->setText(i-1,4,temp);

		// Dauer %
		double ProzentDauer=100 * SummenTabelle[i].Dauer / GesamtDauer();
		ProzentDauer = runden(ProzentDauer * 10)/10;
		temp="%1%"; temp=temp.arg(ProzentDauer);
		diag->TabSum->setText(i-1,5,temp);

		// UnterDauer %
		HundertProzent=(i<=3)?DauerTherapeut:DauerKlient; 
		double ProzentTeilDauer=100 * SummenTabelle[i].Dauer / HundertProzent;
		ProzentTeilDauer = runden(ProzentTeilDauer * 10)/10;
		temp="%1%"; temp=temp.arg(ProzentTeilDauer);
		diag->TabSum->setText(i-1,7,temp);
	}
	// "nix" UnterWerte berschreiben
	diag->TabSum->setText(6,3,"");
	diag->TabSum->setText(6,7,"");

	temp="%1"; temp=temp.arg(PassungAnzahl);
	diag->UnteranzahlenQuotient->setText(temp);
	temp="%1"; temp=temp.arg(PassungDauer);
	diag->UnterdauernQuotient->setText(temp);

	// Zweier- und Dreier bergnge:
	int j,k, zeile; 
	double prozent, prozentsumme=0, prozentDreier, prozentsummeDreier=0;
	long anzahlDreier=0;
	for (i=1; i<8; i++){
		for (j=1; j<8; j++){
			temp="%1"; temp=temp.arg(uew[i][j]);
			diag->TabUew->setText(i-1,j-1,(uew[i][j]==0?"":temp) );
			prozent=runden(uew[i][j] / (double)(GesamtAnzahl() -1 ) * 1000)/10;
			prozentsumme+=prozent;
			temp="%1%"; temp=temp.arg(prozent);
			diag->TabUewProzent->setText(i-1,j-1,(uew[i][j]==0?"":temp) );

			for (k=1; k<=7; k++){
				temp="%1"; temp=temp.arg(uew2[k][i][j]);
				zeile=(i-1)*7 + k-1;
				diag->TabUew2->setText(zeile,j-1,(uew2[k][i][j]==0?"":temp) );
				anzahlDreier+=uew2[k][i][j];

				// Prozenttabelle:
				prozentDreier=runden(1000*(uew2[k][i][j]/((double)GesamtAnzahl()-2)))/10;
				temp="%1%"; temp=temp.arg(prozentDreier);
				zeile=(i-1)*7 + k-1;
				diag->TabUew2Prozent->setText(zeile,j-1,(uew2[k][i][j]==0?"":temp) );
				prozentsummeDreier+=prozentDreier;
			}
		}
	}

	for (i=0; i<=7; i++){
		diag->TabSum->adjustColumn(i); // zuflligerweise sind das auch 8 Spalten
		diag->TabUew->adjustColumn(i);
		diag->TabUewProzent->adjustColumn(i);
		diag->TabUew2->adjustColumn(i);
		diag->TabUew2Prozent->adjustColumn(i);
	}
	temp="%1%"; temp=temp.arg(prozentsumme);
	diag->Prozentsumme->setText(temp );

	temp="%1"; temp=temp.arg(anzahlDreier);
	diag->AnzahlDreier->setText(temp );

	temp="%1%"; temp=temp.arg(prozentsummeDreier);
	diag->ProzentsummeDreier->setText(temp );

	temp="%1%"; temp=temp.arg(runden(AufnahmeLoesFok*1000)/10);
	diag->AufnahmeLoesFok->setText(temp);
	temp="%1%"; temp=temp.arg(runden(verspaetAufnahmeLoesFok*1000)/10);
	diag->verspaetAufnahmeLoesFok->setText(temp);
	temp="%1%"; temp=temp.arg(runden(TherapNLAnpassung*1000)/10);
	diag->TherapNLAnpassung->setText(temp);
	temp="%1%"; temp=temp.arg(runden(TherapFrustration*1000)/10);
	diag->TherapFrustration->setText(temp);

	// ganzen Verlauf einfach anzeigen:
	diag->TabVerlauf->setNumRows(GesamtAnzahl()+1);
	RatingSkala vorherigeEinsch=null, aktuelleEinsch=null, nachherEinsch;
	long zaehler=0;
	IntervallErgebnis interv;
	MinSec2Rating::iterator it=Verlauf->Sinneinheiten.begin();
	for ( ; it!=Verlauf->Sinneinheiten.end(); it++){
		interv=Verlauf->RatingAuslesen(it);
		nachherEinsch=interv.Einschaetzung;
		temp="%1"; temp=temp.arg(it->first.toQString());
		diag->TabVerlauf->setText(zaehler,0,temp);

		temp="%1"; temp=temp.arg(vorherigeEinsch);
		diag->TabVerlauf->setText(zaehler,1,vorherigeEinsch==0?"":temp);
		temp="%1"; temp=temp.arg(aktuelleEinsch);
		diag->TabVerlauf->setText(zaehler,2,aktuelleEinsch==0?"":temp);
		temp="%1"; temp=temp.arg(nachherEinsch);
		diag->TabVerlauf->setText(zaehler,3,nachherEinsch==0?"":temp);
		temp="%1"; temp=temp.arg(interv.Dauer);
		diag->TabVerlauf->setText(zaehler,4,interv.Dauer==0?"":temp);
		vorherigeEinsch=aktuelleEinsch;
		aktuelleEinsch=nachherEinsch;

		zaehler++;
	}

	for (i=0; i<=4; i++){
		diag->TabVerlauf->adjustColumn(i);
		diag->TabVerlaufAlt->adjustColumn(i);
	}

}
