#include "lftvideoanalysedialog.h"
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtable.h>


LFTVideoAnalyseDialog::LFTVideoAnalyseDialog( QWidget* parent, const char* name, bool modal, WFlags f )
	: LFTVideoAnalyseDialogBase( parent, name, modal, f )
{

	TextLabelTitel->setText("LFT Video Analyse Tool (v0.96)");

	Verlauf=new RatingVerlauf();
	Auswertung=new VerlaufsAuswertung(); 

	// Spalten-Namen setzen
	TabSum->horizontalHeader()->setLabel(0,"Anzahl(#)");
	TabSum->horizontalHeader()->setLabel(1,"Anzahl(%)");
    TabSum->horizontalHeader()->setLabel(2,"TeilAnzahl(%)");
	TabSum->horizontalHeader()->setLabel(3,"UnterAnzahl(%)");

	TabSum->horizontalHeader()->setLabel(4,"Dauer(sec)");
	TabSum->horizontalHeader()->setLabel(5,"Dauer(%)");
	TabSum->horizontalHeader()->setLabel(6,"TeilDauer(%)");
	TabSum->horizontalHeader()->setLabel(7,"UnterDauer(%)");

	TabSum->setText(0,2," ");
	TabSum->item(0,2)->setSpan(3,1);
	TabSum->setText(3,2," ");
	TabSum->item(3,2)->setSpan(3,1);

	TabSum->setText(0,6," ");
	TabSum->item(0,6)->setSpan(3,1);
	TabSum->setText(3,6," ");
	TabSum->item(3,6)->setSpan(3,1);
		
	// resizen der Spalten passiert nun nach Fllen...
	/*for (int i=0; i<=3; i++){
		QFontMetrics FM(this->font());
		QString temp=TabSum->horizontalHeader()->label(i);
		int width=1.2*FM.boundingRect(temp).width();
		TabSum->horizontalHeader()->resizeSection(i,width);
	}
	*/

	connect((QObject*)(this->ButtonDatenEinlesen), SIGNAL(pressed()),
		this, SLOT(DatenEinlesen()));

	connect((QObject*)(this->ButtonVerkuerze), SIGNAL(pressed()),
		this, SLOT(DatensatzVerkuerzen()));

	//connect((QObject*)(this->ButtonSpeichern), SIGNAL(pressed()),
	//	this, SLOT(AuswertungSpeichernV09()));

	/*
	// etwas unsauber, 
	// aber ich baue das bergangswahrscheinlichkeiten-Fenster einfach hier
	uewDialog =new QDialog ( this, "bergangswahrscheinlichkeiten", TRUE, (WFlags)0 );
	TabUew = new QTable( uewDialog, "TabUew" );
    TabUew->setGeometry( QRect( 10, 25, 580, 180 ) ); 
    TabUew->setProperty( "numRows", 7 );
    TabUew->setProperty( "numCols", 7 );

	buttonUewOK=new QPushButton (uewDialog , "ButtonOK");
    buttonUewOK->setProperty( "text", tr( "&OK" ) );
    buttonUewOK->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
	connect((QObject*)(buttonUewOK), SIGNAL(pressed()),
		uewDialog , SLOT(accept()));

    LayoutUew = new QVBoxLayout( uewDialog ); 
    LayoutUew->setSpacing( 6 );
    LayoutUew->setMargin( 0 );
	LayoutUew->addWidget( buttonUewOK );
	LayoutUew->addWidget( TabUew );
	*/

	QString text;
	int i, k;
	for (i=1; i<=7; i++){
		TabRatingSkala->setText(i-1,0,RatingSkalaKurz[i]);
		TabRatingSkala->setText(i-1,1,RatingSkalaLang[i]);
		for (k=1; k<=7; k++){
			text="%1>%2"; text=text.arg(i).arg(k);
			TabUew2->verticalHeader()->setLabel((k-1)*7 + i-1, text);
			TabUew2Prozent->verticalHeader()->setLabel((k-1)*7 + i-1, text);
		}
	}
	TabRatingSkala->adjustColumn(0);
	TabRatingSkala->adjustColumn(1);

	TabVerlauf->horizontalHeader()->setLabel(0,"Zeit");
	TabVerlauf->horizontalHeader()->setLabel(1,"Einsch_VorVorher");
	TabVerlauf->horizontalHeader()->setLabel(2,"Einsch_Vorher");
	TabVerlauf->horizontalHeader()->setLabel(3,"Einsch_Ende");
	TabVerlauf->horizontalHeader()->setLabel(4,"Dauer");

	TabVerlaufAlt->horizontalHeader()->setLabel(0,"Zeit");
	TabVerlaufAlt->horizontalHeader()->setLabel(1,"Einsch_VorVorher");
	TabVerlaufAlt->horizontalHeader()->setLabel(2,"Einsch_Vorher");
	TabVerlaufAlt->horizontalHeader()->setLabel(3,"Einsch_Ende");
	TabVerlaufAlt->horizontalHeader()->setLabel(4,"Dauer");

	connect((QObject*)(this->TabUew2Prozent), SIGNAL(contentsMoving ( int , int ) ),
		this, SLOT(DreiertabelleScrollen ( int , int )));
}

void LFTVideoAnalyseDialog::DreiertabelleScrollen(int x, int y){
	TabUew2->setContentsPos(x,y);
}

void LFTVideoAnalyseDialog::DatenEinlesen(){
	if (Rater->text()=="" || Klient->text()=="") {
		EinlesenInfoLabel->setText("Bitte zunchst Klientencode und Ratername eingeben.");
		return; 
	} 
	EinlesenInfoLabel->setText("");

	Speicherer = new VerlaufSpeichern();
	QString dateiname=Speicherer->gibFilename(Klient->text(), Rater->text());
	Speicherer->setzePointerAufDaten(Verlauf);

	bool erfolgreich = Speicherer->leseDaten(dateiname,"Rating Verlauf");
	if (! erfolgreich) {
		EinlesenInfoLabel->setText(tr("%1 konnte nicht eingelesen werden").arg(dateiname));
		ButtonDatenEinlesen->setDown(false);
		return;
	} else {
		EinlesenInfoLabel
			->setText(tr("%1 wurde erfolgreich eingelesen und die Auswertung gespeichert.").arg(dateiname));
	}

	delete Speicherer;

	Auswertung->DatenAnalysieren(Verlauf);
	Auswertung->DatenAnzeigen(this);

	SpeichereAuswertung("Auswertung");	
}

void LFTVideoAnalyseDialog::DatensatzVerkuerzen(){

	//QString temp=Verlauf
	//   ->printGesamtenRatingVerlauf (MinSec(0,0), Verlauf->BisherLetzterMoment());
	//qDebug(temp);

	// alte Version in untere Verlaufstabelle kopieren:
	//TabVerlaufAlt=TabVerlauf;
	int numRows=TabVerlauf->numRows();
	int numCols=TabVerlauf->numCols();
	TabVerlaufAlt->setNumRows(numRows);
	TabVerlaufAlt->setNumCols(numCols);
	int i, j;
	for (i=0; i<numRows; i++){
		for (j=0; j<numCols; j++){
			TabVerlaufAlt->setText(i,j, TabVerlauf->text(i,j) );
		}
	}
	
	long umWieviel=Verlauf->verkuerzeUmAufeinanderfolgendGleiche();
	VerkuerzenInfoLabel->
		setText(tr("Datensatz wurde um %1 Sinneinheiten verkrzt "
		           "und die neue Auswertung(verkuerzt) gespeichert.").arg(umWieviel));

	Auswertung->DatenAnalysieren(Verlauf);
	Auswertung->DatenAnzeigen(this);

	SpeichereAuswertung("Auswertung(verkuerzt)");

	//temp=Verlauf->
	//       printGesamtenRatingVerlauf (MinSec(0,0), Verlauf->BisherLetzterMoment());
	//qDebug(temp);

}

void LFTVideoAnalyseDialog::AuswertungSpeichernV09(){
	int r,c;
	QString temp;

	temp+=tr("%1\t").arg(DauerGesamt->text());
	temp+=tr("%1\t").arg(DauerTherapeut->text());
	temp+=tr("%1\n").arg(DauerKlient->text());
	temp+=tr("%1\t").arg(AnzahlGesamt->text());
	temp+=tr("%1\t").arg(AnzahlTherapeut->text());
	temp+=tr("%1\n").arg(AnzahlKlient->text());
	temp+=tr("%1\t").arg(mittlereDauerGesamt->text());
	temp+=tr("%1\t").arg(mittlereDauerTherapeut->text());
	temp+=tr("%1\n\n").arg(mittlereDauerKlient->text());

	for ( r=0; r<=6; r++){
		temp+=tr("%1\t").arg(r+1);
		for ( c=0; c<=7; c++){
			temp+=TabSum->text(r,c);
			temp+='\t';
		}
		temp+='\n';
	};

	QStringSpeichern* AuswertungsSpeicherer = new QStringSpeichern();
	AuswertungsSpeicherer->merkDirDaten(temp, "AuswertungV09");
	QString fname=AuswertungsSpeicherer->gibFilename(Klient->text(), Rater->text());
	AuswertungsSpeicherer->speichereDaten(fname, "AuswertungV09");
	delete AuswertungsSpeicherer ;
}


void LFTVideoAnalyseDialog::SpeichereAuswertung(QString dieEndung){

	// Auswertung aggregierte Daten
	AuswertungSpeichern* AuswSpeicherer;
	AuswSpeicherer= new AuswertungSpeichern();
	AuswSpeicherer->merkDirDaten(Auswertung, dieEndung);

	QString fname=AuswSpeicherer->gibFilename(Klient->text(), Rater->text());
	AuswSpeicherer->speichereDaten(fname, dieEndung);
	delete AuswSpeicherer;


	// bergangswahrscheinlichkeiten
	QString temp, uebergaenge="";
	QString id=Klient->text() + '\t' + Rater->text() + '\t';
	int i, j;

	for (i=1; i<=7; i++){
		for (j=1; j<=7; j++){
			temp="%1"; temp=temp.arg(Auswertung->uew[i][j]);
			uebergaenge += temp + '\t';
		}
		temp="%1"; temp=temp.arg(i);
		uebergaenge += id + temp + '\n';
	}

	QStringSpeichern* UeWSpeicherer;  
	UeWSpeicherer= new QStringSpeichern();
	UeWSpeicherer->merkDirDaten(uebergaenge, dieEndung+"_UeW");

	fname=UeWSpeicherer->gibFilename(Klient->text(), Rater->text());
	UeWSpeicherer->speichereDaten(fname, dieEndung);
	delete UeWSpeicherer;

	// bergangswahrscheinlichkeiten2 fr Dreier-bergnge
	uebergaenge="";
	int k;
	for (i=1; i<=7; i++){
		for (j=1; j<=7; j++){
			for (k=1; k<=7; k++){
				//                              warum j i k, nicht i j k?
				temp="%1"; temp=temp.arg(Auswertung->uew2[j][i][k]); 
				uebergaenge += temp + '\t';
			}
			temp="%1\t%2"; temp=temp.arg(j).arg(i);
			uebergaenge += id + temp + '\n';
		}
	}

	QStringSpeichern* UeW2Speicherer;  
	UeW2Speicherer= new QStringSpeichern();
	UeW2Speicherer->merkDirDaten(uebergaenge, dieEndung+"_UeW2");

	fname=UeW2Speicherer->gibFilename(Klient->text(), Rater->text());
	UeW2Speicherer->speichereDaten(fname, dieEndung);
	delete UeW2Speicherer;

}
