// sitzungskonfigurationdialog.cpp
// LFTVideo.cpp  v1.7
//               12.5.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp

#include "sitzungskonfigurationdialog.h"

#include <qlineedit.h>
#include <qlabel.h>
#include <qfile.h>
#include <qpushbutton.h>
#include <qdatetime.h> 

SitzungsKonfigurationDialog::SitzungsKonfigurationDialog( QWidget* parent, 
									const char* name, bool modal, WFlags f )
	: SitzungsKonfigurationDialogBase( parent, name, modal, f )
{

	// Add your code
	LineEditInfodatei->setReadOnly(true);
	buttonOk->setEnabled(false);

	LineEditInfodatei->setPalette( parent->palette() );
	LineEditDatum->setPalette( parent->palette() );
	LineEditUhrzeit->setPalette( parent->palette() );


	// signals and slots connections
	// fertig -> checking und filename anzeigen
	connect( (const QObject*) PushButtonFertig, SIGNAL(clicked() ), 
		this, SLOT( showTheFilename() ) );

	// wenn sich was ndert, geht OK erstmal nicht mehr:
	connect( (const QObject*) LineEditRater, 
		SIGNAL(textChanged(const QString &) ), this, SLOT( disableOK() ) );
	connect( (const QObject*) LineEditKlient, 
		SIGNAL(textChanged(const QString &) ), this, SLOT( disableOK() ) );
	connect( (const QObject*) ButtonGroupWeiterfuehren, SIGNAL(clicked(int) ), 
		this, SLOT( disableOK() ) );
};

void SitzungsKonfigurationDialog::disableOK(){
	buttonOk->setEnabled(false);
}

void SitzungsKonfigurationDialog::showTheFilename(){

	buttonOk->setEnabled(true);

	if (LineEditKlient->text()==""){
		TextLabelKlient->setPalette( QPalette( QColor(80, 80, 255) ) );
		buttonOk->setEnabled(false);
	} else TextLabelKlient->unsetPalette( );

	if (LineEditRater->text()==""){
		TextLabelRater->setPalette( QPalette( QColor(80, 80, 255) ) );
		buttonOk->setEnabled(false);
	} else TextLabelRater->unsetPalette( );

	LineEditInfodatei->setText(filename());

	LineEditDatum->setText(QDate::currentDate().toString());

    QFile f( filename() );
    bool ok=f.open( IO_ReadOnly );
	if (!ok) {
		TextLabelExistiert->setText("noch nicht");
	}
	else{
		TextLabelExistiert->setText("schon");
		f.close();
	}
};


QString SitzungsKonfigurationDialog::filename(){
	return (LineEditKlient->text() + "_" 
		    + LineEditRater->text() +"_info.dat").lower();
};

